Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/NST_SRC/agrif_oce.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/NST_SRC/agrif_oce.F90	(revision 9057)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/NST_SRC/agrif_oce.F90	(revision 9058)
@@ -26,5 +26,5 @@
    REAL(wp), PUBLIC ::   rn_sponge_dyn = 2800.     !: sponge coeff. for dynamics
    LOGICAL , PUBLIC ::   ln_chk_bathy  = .FALSE.   !: check of parent bathymetry 
-   LOGICAL , PUBLIC ::   lk_agrif_clp  = .TRUE.    !: Force clamped bcs
+   LOGICAL , PUBLIC ::   lk_agrif_clp  = .FALSE.   !: Force clamped bcs
    !                                              !!! OLD namelist names
    REAL(wp), PUBLIC ::   visc_tra                  !: sponge coeff. for tracers
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/NST_SRC/agrif_user.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/NST_SRC/agrif_user.F90	(revision 9057)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/NST_SRC/agrif_user.F90	(revision 9058)
@@ -411,11 +411,11 @@
    CALL agrif_declare_variable((/2,2/),(/ind3,ind3/),(/'x','y'/),(/1,1/),(/nlci,nlcj/),sshn_id)
 
-   IF( ln_zdftke ) THEN
-      CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/), en_id)
-      CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/),avt_id)
+   IF( ln_zdftke.OR.ln_zdfgls ) THEN
+!      CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/), en_id)
+!      CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/jpi,jpj,jpk/),avt_id)
 # if defined key_vertical
-   CALL agrif_declare_variable((/2,2,0,0/),(/ind3,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/jpi,jpj,jpk,2/),avm_id)
+      CALL agrif_declare_variable((/2,2,0,0/),(/ind3,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/jpi,jpj,jpk,2/),avm_id)
 # else
-   CALL agrif_declare_variable((/2,2,0,0/),(/ind3,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,1/),avm_id)
+      CALL agrif_declare_variable((/2,2,0,0/),(/ind3,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,1/),avm_id)
 # endif
    ENDIF
@@ -444,5 +444,5 @@
    CALL Agrif_Set_bcinterp(vmsk_id,interp=AGRIF_constant)
 
-   IF( ln_zdftke )   CALL Agrif_Set_bcinterp( avm_id, interp=AGRIF_linear )
+   IF( ln_zdftke.OR.ln_zdfgls )   CALL Agrif_Set_bcinterp( avm_id, interp=AGRIF_linear )
 
    ! 3. Location of interpolation
@@ -466,5 +466,5 @@
    CALL Agrif_Set_bc( vmsk_id, (/0,ind1-1/)                  )
 
-   IF( ln_zdftke )   CALL Agrif_Set_bc( avm_id, (/0,ind1/) )
+   IF( ln_zdftke.OR.ln_zdfgls )   CALL Agrif_Set_bc( avm_id, (/0,ind1/) )
 
    ! 4. Update type
@@ -482,8 +482,8 @@
    CALL Agrif_Set_Updatetype(e3t_id, update = Agrif_Update_Full_Weighting)
 
-   IF( ln_zdftke) THEN
-      CALL Agrif_Set_Updatetype( en_id, update = AGRIF_Update_Full_Weighting)
-      CALL Agrif_Set_Updatetype(avt_id, update = AGRIF_Update_Full_Weighting)
-      CALL Agrif_Set_Updatetype(avm_id, update = AGRIF_Update_Full_Weighting)
+   IF( ln_zdftke.OR.ln_zdfgls ) THEN
+!      CALL Agrif_Set_Updatetype( en_id, update = AGRIF_Update_Full_Weighting)
+!      CALL Agrif_Set_Updatetype(avt_id, update = AGRIF_Update_Full_Weighting)
+!      CALL Agrif_Set_Updatetype(avm_id, update = AGRIF_Update_Full_Weighting)
    ENDIF
 
@@ -498,8 +498,8 @@
    CALL Agrif_Set_Updatetype(e3t_id, update = AGRIF_Update_Average)
 
-   IF( ln_zdftke) THEN
-      CALL Agrif_Set_Updatetype( en_id, update = AGRIF_Update_Average)
-      CALL Agrif_Set_Updatetype(avt_id, update = AGRIF_Update_Average)
-      CALL Agrif_Set_Updatetype(avm_id, update = AGRIF_Update_Average)
+   IF( ln_zdftke.OR.ln_zdfgls ) THEN
+!      CALL Agrif_Set_Updatetype( en_id, update = AGRIF_Update_Average)
+!      CALL Agrif_Set_Updatetype(avt_id, update = AGRIF_Update_Average)
+!      CALL Agrif_Set_Updatetype(avm_id, update = AGRIF_Update_Average)
    ENDIF
 