Index: /branches/2017/dev_merge_2017/NEMOGCM/SETTE/sette.sh
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/SETTE/sette.sh	(revision 9109)
+++ /branches/2017/dev_merge_2017/NEMOGCM/SETTE/sette.sh	(revision 9110)
@@ -886,5 +886,5 @@
     . ./prepare_exe_dir.sh
     JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=32
+    NPROC=15
     if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
     cd ${EXE_DIR}
@@ -894,18 +894,10 @@
     set_namelist namelist_cfg nn_stock 48
     set_namelist namelist_cfg ln_clobber .true.
-    #SF come back to reading of domain_cfg for ISOMIP
-    #SF change after merge, when usrdef_zgr will be correct
-    set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg cn_domcfg ISOMIP_zps_domcfg
-    #SF come back to reading of domain_cfg for ISOMIP
+    set_namelist namelist_cfg ln_read_cfg .false.
     set_namelist namelist_cfg ln_icebergs .false.
     set_namelist namelist_cfg ln_bergdia .false.
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    set_namelist namelist_cfg ln_non_lin .false.
-    set_namelist namelist_cfg ln_lin .true.
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    set_namelist namelist_cfg jpni 4
-    set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg jpnij 32
+    set_namelist namelist_cfg jpni 5
+    set_namelist namelist_cfg jpnj 3
+    set_namelist namelist_cfg jpnij 15
     if [ ${USING_MPMD} == "yes" ] ; then
        set_xio_using_server iodef.xml true
@@ -927,18 +919,9 @@
     set_namelist namelist_cfg nn_rstctl 2
     set_namelist namelist_cfg ln_clobber .true.
-    #SF come back to reading of domain_cfg for ISOMIP
-    #SF change after merge, when usrdef_zgr will be correct
-    set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg cn_domcfg ISOMIP_zps_domcfg
-    #SF come back to reading of domain_cfg for ISOMIP
+    set_namelist namelist_cfg ln_read_cfg .false.
     set_namelist namelist_cfg ln_bergdia .false.
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    set_namelist namelist_cfg ln_non_lin .false.
-    set_namelist namelist_cfg ln_lin .true.
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    set_namelist namelist_cfg jpni 4
-    set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg jpnij 32
+    set_namelist namelist_cfg jpni 5
+    set_namelist namelist_cfg jpnj 3
+    set_namelist namelist_cfg jpnij 15
     set_namelist namelist_cfg cn_ocerst_in \"ISOMIP_LONG_00000048_restart\"
     if [ ${USING_MPMD} == "yes" ] ; then
@@ -963,33 +946,24 @@
 
     ## Reproducibility tests for ISOMIP
-    export TEST_NAME="REPRO_4_8"
-    cd ${CONFIG_DIR0}
-    cd ${SETTE_DIR}
-    . ./param.cfg
-    . ./all_functions.sh
-    . ./prepare_exe_dir.sh
-    JOB_FILE=${EXE_DIR}/run_job.sh
-    NPROC=32
-    if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
-    cd ${EXE_DIR}
-    set_namelist namelist_cfg cn_exp \"ISOMIP_48\"
+    export TEST_NAME="REPRO_7_3"
+    cd ${CONFIG_DIR0}
+    cd ${SETTE_DIR}
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
+    JOB_FILE=${EXE_DIR}/run_job.sh
+    NPROC=21
+    if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
+    cd ${EXE_DIR}
+    set_namelist namelist_cfg cn_exp \"ISOMIP_73\"
     set_namelist namelist_cfg nn_it000 1
     set_namelist namelist_cfg nn_itend 48
     set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg ln_clobber .true.
-    #SF come back to reading of domain_cfg for ISOMIP
-    #SF change after merge, when usrdef_zgr will be correct
-    set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg cn_domcfg ISOMIP_zps_domcfg
-    #SF come back to reading of domain_cfg for ISOMIP
+    set_namelist namelist_cfg ln_read_cfg .false.
     set_namelist namelist_cfg ln_bergdia .false.
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    set_namelist namelist_cfg ln_non_lin .false.
-    set_namelist namelist_cfg ln_lin .true.
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    set_namelist namelist_cfg jpni 4
-    set_namelist namelist_cfg jpnj 8
-    set_namelist namelist_cfg jpnij 32
+    set_namelist namelist_cfg jpni 7
+    set_namelist namelist_cfg jpnj 3
+    set_namelist namelist_cfg jpnij 21
     if [ ${USING_MPMD} == "yes" ] ; then
        set_xio_using_server iodef.xml true
@@ -1014,15 +988,6 @@
     set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg ln_clobber .true.
-    #SF come back to reading of domain_cfg for ISOMIP
-    #SF change after merge, when usrdef_zgr will be correct
-    set_namelist namelist_cfg ln_read_cfg .true.
-    set_namelist namelist_cfg cn_domcfg ISOMIP_zps_domcfg
-    #SF come back to reading of domain_cfg for ISOMIP
+    set_namelist namelist_cfg ln_read_cfg .false.
     set_namelist namelist_cfg ln_bergdia .false.
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
-    set_namelist namelist_cfg ln_non_lin .false.
-    set_namelist namelist_cfg ln_lin .true.
-    #SF TO BE REMOVED AFTER BUG CORRECTION OF ln_not_lin drg
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4